原题:Leetcode160
点击跳转
编写一个程序,找到两个单链表相交的起始节点。
如下面的两个链表:
在节点 c1 开始相交。
示例1:
输入:intersectVal = 8, listA = [4,1,8,4,5], listB = [5,0,1,8,4,5], skipA = 2, skipB = 3
输出:Reference of the node with value = 8
输入解释:相交节点的值为 8 (注意,如果两个列表相交则不能为 0)。从各自的表头开始算起,链表 A 为 [4,1,8,4,5],链表 B 为 [5,0,1,8,4,5]。在 A 中,相交节点前有 2 个节点;在 B 中,相交节点前有 3 个节点。
示例2:
输入:intersectVal = 2, listA = [0,9,1,2,4], listB = [3,2,4], skipA = 3, skipB = 1
输出:Reference of the node with value = 2
输入解释:相交节点的值为 2 (注意,如果两个列表相交则不能为 0)。从各自的表头开始算起,链表 A 为 [0,9,1,2,4],链表 B 为 [3,2,4]。在 A 中,相交节点前有 3 个节点;在 B 中,相交节点前有 1 个节点。
示例3:
输入:intersectVal = 0, listA = [2,6,4], listB = [1,5], skipA = 3, skipB = 2
输出:null
输入解释:从各自的表头开始算起,链表 A 为 [2,6,4],链表 B 为 [1,5]。由于这两个链表不相交,所以 intersectVal 必须为 0,而 skipA 和 skipB 可以是任意值。
解释:这两个链表不相交,因此返回 null。
其中关于ListNode节点的定义
/**
/**
* Definition for singly-linked list.
* public class ListNode {
* public int val;
* public ListNode next;
* public ListNode(int x) { val = x; }
* }
*/
1.暴力解法,对于每个A中的节点直接遍历B中的所有节点找一样的就返回。
public class Solution {
public ListNode GetIntersectionNode(ListNode headA, ListNode headB) {
if(headA==null||headB==null)
return null;
while(headA!=null)
{
if(GetInter(headA,headB)!=null)
return GetInter(headA,headB);
headA=headA.next;
}
return null;
}
public ListNode GetInter(ListNode NodeA,ListNode NodeB)
{
while(NodeB!=null)
{
if(NodeA==NodeB)
return NodeA;
NodeB=NodeB.next;
}
return null;
}
}
结果很烂但是也在意料之中
2.HashSet
这题也可以用哈希表的思路去做,将A中的节点记录到哈希表中,然后顺序遍历B中的节点,第一个包含在哈希表中的节点就是满足条件的节点。
public class Solution {
public ListNode GetIntersectionNode(ListNode headA, ListNode headB) {
if(headA==null||headB==null)
return null;
HashSet<ListNode> s = new HashSet<ListNode>();
while(headA!=null)
{
s.Add(headA);
headA = headA.next;
}
while(headB!=null)
{
if (s.Contains(headB))
return headB;
headB = headB.next;
}
return null;
}
}